{ *************************
  Componente enviado por:
  orpolonio@hotmail.com
  *************************** }
  
unit MyEdit;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask;

type
	TTipo = (meEmBrancoPode,meTextoObrigatorio,meDataMaiorHoje,meDataMenorHoje,meFloatMenorIgualZero,meFloatMenorZero,meInteiroMenorIgualZero,meInteiroMenorZero,meChecaInput,meMinimoDigitosTAG,meFloatValido,meDataValida,meInteiroValido,meDataEmBrancoPode);
  MeuEdit = class(TCustomMaskEdit)

  private
    FCanvas:    TControlCanvas;
    FAlignment: TAlignment;
    FFocused: Boolean;
    FMinimo:Integer;
    FMaximo:Integer;
    FDecimais:Integer;
    FPodeSair:boolean;
    FTipo: TTipo;
    FDefault:String;
    FqData : TDateTime;
    FsqlValida : String;
    Unidade  : array[0..9] of string[7];
    Dezena   : array[0..9] of string[10];
    Centena  : array[0..9] of string[13];
    FMoeda,
    FPluralMoeda,
    FFracao,
    FPluralFracao,
    FNumero,
    FExtenso : string;
    FEINE:Integer;         (* novo 25/07 *)
    procedure SetNumero(Value : string);
    procedure SetMoeda(Value : string);
    procedure SetPluralMoeda(Value : string);
    procedure SetFracao(Value : string);
    procedure SetPluralFracao(Value : string);
    function Ext1(S : string) : string;
    function ExtUnidade(S : string) : string;
    function ExtDezena(S : string) : string;
    function Ext2(S : string) : string;
		Function EMascara (L : Char) : Boolean;
		Function PoeMascara (pTexto : String) : String;
		Function TiraMascara (pTexto : String) : String;
    Procedure SetTipo (Value:TTipo);
    Procedure SetDecimais (Value:Integer);
    procedure SetqData(Value:TDateTime);
    procedure SetSqlValida(Value:String);
    procedure DataChange(Sender: TObject);
    procedure UpdateData(Sender: TObject);
    procedure WMCut(var Message: TMessage); message WM_CUT;
    procedure WMPaste(var Message: TMessage); message WM_PASTE;
    procedure CMEnter(var Message: TCMEnter); message CM_ENTER;
    procedure CMExit(var Message: TCMExit); message CM_EXIT;
    procedure WMPaint(var Message: TWMPaint); message WM_PAINT;

  // secao protegida
  protected
    procedure Change; override;
    function EditCanModify: Boolean; override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyPress(var Key: Char); override;
    procedure Notification(AComponent: TComponent;Operation: TOperation); override;
    procedure Reset; override;
    procedure SetFocused(Value: Boolean);
    function GetTextMargins: TPoint;

  // secao publica
  public
    Constructor Create(AOwner: TComponent); override;
    Destructor Destroy; override;

  // secao o object inspector
  published
    property AutoSelect;
    property CharCase;
    property Color;
    property editMask;
    property IniciaCampo: String read FDefault Write FDefault;
    property Enabled;
	  property Excecao: TTipo read FTipo write SetTipo default meEmBrancoPode;
    property Font;
    property MaxLength;
    property PasswordChar;
    property PopupMenu;
    property ShowHint;
    property ReadOnly;
    property TabOrder;
    property TabStop;
    property Visible;
	  property VlrMaximo: Integer read FMaximo Write FMaximo;
    property VlrMinino: Integer read FMinimo Write FMinimo;
    property Decimais : Integer read FDecimais Write FDecimais;
    property PodeSair : Boolean read FPodeSair write FPodeSair;
    property SqlValida : String read FSqlValida Write FSqlValida;
    property qData : TDateTime read FqData write SetqData;
    property OnChange;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
    property Moeda : string read FMoeda write SetMoeda;
    property PluralMoeda : string read FPluralMoeda write SetPluralMoeda;
    property Fracao : string read FFracao write SetFracao;
    property PluralFracao : string read FPluralFracao write SetPluralFracao;
    property Numero : string read FNumero write SetNumero;
    property Extenso : string read FExtenso write FExtenso;
    property EINE	:	integer read FEINE write FEINE;	     (* novo 25/07 *)
    { Published declarations }
  end;

procedure Register;

implementation

Constructor meuEdit.Create(AOwner: TComponent);
Begin
  inherited Create(AOwner);
	FTipo := meEmBrancoPode;
	IniciaCampo:=FDefault;
  FPodeSair := False;
	FMinimo:=0;
	FMaximo:=0;
  FDecimais:=0;
  FEINE:=0;

  {Unidades}
  Unidade[0] := '';
  Unidade[1] := 'um ';
  Unidade[2] := 'dois ';
  Unidade[3] := 'tres ';
  Unidade[4] := 'quatro ';
  Unidade[5] := 'cinco ';
  Unidade[6] := 'seis ';
  Unidade[7] := 'sete ';
  Unidade[8] := 'oito ';
  Unidade[9] := 'nove ';
  {Dezenas}
  Dezena[0] := '';
  Dezena[1] := 'dez ';
  Dezena[2] := 'vinte ';
  Dezena[3] := 'trinta ';
  Dezena[4] := 'quarenta ';
  Dezena[5] := 'cinquenta ';
  Dezena[6] := 'sessenta ';
  Dezena[7] := 'setenta ';
  Dezena[8] := 'oitenta ';
  Dezena[9] := 'noventa ';
  {Centenas}
  Centena[0] := '';
  Centena[1] := 'cem ';
  Centena[2] := 'duzentos ';
  Centena[3] := 'trezentos ';
  Centena[4] := 'quatrocentos ';
  Centena[5] := 'quinhentos ';
  Centena[6] := 'seiscentos ';
  Centena[7] := 'setecentos ';
  Centena[8] := 'oitocentos ';
  Centena[9] := 'novecentos ';
  FNumero := '0,00';
  FMoeda := 'Real';
  FPluralMoeda := 'Reais';
  FFracao := 'centavo';
  FPluralFracao := 'centavos';

  ControlStyle := ControlStyle + [csReplicatable];
End;

Destructor meuEdit.Destroy;
Begin
  FCanvas.Free;
  Inherited Destroy;
End;

Procedure meuEdit.Notification(AComponent: TComponent;Operation: TOperation);
Begin
  Inherited Notification(AComponent, Operation);
End;

Procedure meuEdit.SetTipo (Value:TTipo);
Begin
	If FTipo <> Value Then Begin
    	FTipo:=Value;
     Invalidate;
  End;
End;


Procedure meuEdit.SetqData(Value:TDateTime);
Begin
	If FqData <> Value Then Begin
    	FqData:=Value;
     Text := FormatDateTime('ddmmyyyy', FqData);
     Invalidate;
  End;
End;


Procedure meuEdit.SetDecimais (Value:Integer);
begin
  if FDecimais <> Value then begin
     FDecimais := Value;
     invalidate;
  end;
end;

Procedure meuEdit.SetSqlValida (Value:String);
begin
  if FSqlValida <> Value then begin
     FSqlValida := Value;
     invalidate;
  end;
end;

procedure meuEdit.CMEnter(var Message: TCMEnter);
begin

	Font.Color:=clBlack;
  Color := clWhite;
  SetFocused(True);

	(* Tirei em 18/04/2002
	Color := clBlue;
	Font.Color:=clWhite;
	*)
	Font.Style := [];
  podeSair := False;

  if fTipo in [medataMaiorHoje, medataMenorHoje, medataValida, meDataEmBrancoPode] then
     editMask := '99/99/9999;1;_';
  inherited;
end;

Procedure meuEdit.CMExit(var Message: TCMExit);
Var
  aMen:Array[01..11,01..11] of String[100];
	retINVALIDO,retERRO:Integer;
  sTEXTOANTIGO:String;
Begin

  if podeSair then
     exit;

	If(FMinimo>0) AND (StrToInt(Text)<FMinimo) Then Begin
     sTEXTOANTIGO:=Text;
  	ShowMessage('Valor minino aceito '+IntToStr(FMinimo));
     Text:=sTEXTOANTIGO;
     SetFocus;
     Exit;
  End;

	If(FMaximo>0) AND (StrToInt(Text)>FMaximo) Then Begin
	   sTEXTOANTIGO:=Text;
	  	ShowMessage('Valor maximo aceito '+IntToStr(FMaximo));
     Text:=sTEXTOANTIGO;
     SetFocus;
	   Exit;
  End;

	aMen[01,01]:='                                 ';
	aMen[01,02]:='Favor preencher '+ Hint +'... Campo Obrigatrio!';
  aMen[02,01]:='Favor informar uma data valida...';
  aMen[02,02]:='Data Informada no pode ser maior que atual...';
	aMen[03,01]:='Favor informar uma data valida...';
	aMen[03,02]:='Data Informada no pode ser menor que atual...';
  aMen[04,01]:='Favor informar um valor valido...';
  aMen[04,02]:='Favor informar um valor maior que zero...';
	aMen[05,01]:='Favor informar um valor valido...';
	aMen[05,02]:='Favor informar um valor maior ou igual a zero...';
  aMen[06,01]:='Favor informar um numero valido...';
  aMen[06,02]:='Favor informar um numero maior que zero...';
	aMen[07,01]:='Favor informar um numero valido...';
	aMen[07,02]:='Favor informar um numero maior ou igual a zero...';
 	aMen[08,01]:='Favor informar campo com no minimo '+IntToStr(Tag)+' Digitos';
 	aMen[08,02]:='Favor informar campo com no minimo '+IntToStr(Tag)+' Digitos';
  aMen[09,01]:='Favor informar um valor valido...';
	aMen[09,02]:='Favor informar um valor valido...';
  aMen[10,01]:='Favor informar uma Data Valida...';
	aMen[10,02]:='Favor informar uma Data Valida...';
  aMen[11,01]:='Favor informar um Inteiro Valido...';
	aMen[11,02]:='Favor informar um Inteiro Valido...';

	retINVALIDO:=0;
  retERRO:=0;

 	Try
     If (FTipo=meDataMaiorHoje) OR (FTipo=meDataMenorHoje) Then Begin
        retERRO:=2 ;
        StrToDate(Text);
     End;

     If (Ftipo=meFloatMenorIgualZero) OR (Ftipo=meFloatMenorZero) Then Begin
				retERRO:=4;
				If(Copy(Text,01,01)=',') OR (Copy(Text,01,01)='.') Then
        	Text:='0'+Text;
        StrToFloat(Text);
				If(StrToFloat(Text)<0) Then
        	Numero:=FloatToStr((StrToFloat(Text)*-1))
        Else
	        numero:=Text;
     End;

		If(Ftipo=meFloatValido) Then Begin
				retERRO:=9;
				If(Copy(Text,01,01)=',') OR (Copy(Text,01,01)='.') Then
        	Text:='0'+Text;
        StrToFloat(Text);
				If(StrToFloat(Text)<0) Then
        	Numero:=FloatToStr((StrToFloat(Text)*-1))
        Else
	        numero:=Text;
    End;

     If (Ftipo=meInteiroMenorIgualZero) OR (Ftipo=meInteiroMenorZero) Then Begin
      	retERRO:=6;
        StrToInt(Text);
	     (* novo 25/07 *)
        EINE:=StrToInt(Text);
        (**)
     End;

     (* novo 25/07 *)
     If (Ftipo=meInteiroValido) Then
        EINE:=StrToInt(Text);
     (**)

     If (FTipo=meMinimoDigitosTAG) Then
     	retERRO:=8;

     If (FTipo=meDataValida) Then Begin
       	retERRO:=10;
        StrToDate(Text);
		End;

     If (FTipo=meInteiroValido) Then Begin
       	retERRO:=11;
        StrToInt(Text);
		End;

		If(FTipo=meDataEmBrancoPode) Then Begin
			If(Text='') OR (Text='  /  /    ') Then
      Else
      	Begin
	       	retERRO:=10;
  	      StrToDate(Text);
        End;
    End;
	Except
    	Begin
        MessageDlg('RETORNO DO BANCO DE DADOS  SOLICITAO:'+Chr(13)+Chr(13)+aMen[retERRO,01],mtInformation,[mbOk],0);
        SetFocus;
        Exit;
      End;
  End;

  Case FTipo of
  	meTextoObrigatorio		 	:	If(Text='') 							Then retINVALIDO:=1;
    meDataMaiorHoje         : If(StrToDate(Text)>Date) 	Then retINVALIDO:=02;
    meDataMenorHoje         : If(StrToDate(Text)<Date) 	Then retINVALIDO:=03;
    meFloatMenorIgualZero   : If(StrToFloat(Text)<=0)  	Then retINVALIDO:=04;
    meFloatMenorZero        : If(StrToFloat(Text)< 0)  	Then retINVALIDO:=05;
    meInteiroMenorIgualZero : If(StrToInt(Text)<=0)    	Then retINVALIDO:=06;
    meInteiroMenorZero      : If(StrToInt(Text)< 0)    	Then retINVALIDO:=07;
		meMinimoDigitosTAG		 	: If(Length(Text)<Tag) 		 	Then retINVALIDO:=08;
		//FloatValido				 		: If(Length(Text)=0)			 	Then retINVALIDO:=09;
		//DataValida				 		: If(StrToDate(Text)>Date) 	Then retINVALIDO:=10;
    //InteiroValido			 		: If(StrToInt(Text)<=0)    	Then retINVALIDO:=11;
  End;

  If retINVALIDO > 0 Then Begin
     MessageDlg('RETORNO DO BANCO DE DADOS  SOLICITAO:'+Chr(13)+Chr(13)+aMen[retINVALIDO,02],mtInformation,[mbOk],0);
     SetFocus;
     Exit;
  End;

  if fTipo in [mefloatMenorIgualZero, mefloatMenorZero, meFloatValido] then
     text := FormatFloat('##0.'+copy('0000000',1,fDecimais), StrToFloat(text));

	Font.Color:=clBlack;
  Color := clWhite;
  SetFocused(False);
 	CheckCursor;
  DoExit;
End;

procedure meuEdit.UpdateData(Sender: TObject);
begin
  ValidateEdit;
  repaint;
end;

procedure meuEdit.SetFocused(Value: Boolean);
begin
  if FFocused <> Value then begin
    FFocused := Value;
    if (FAlignment <> taLeftJustify) and not IsMasked then
     Invalidate;
  end;
end;

function meuEdit.GetTextMargins: TPoint;
var
  DC: HDC;
  SaveFont: HFont;
  I: Integer;
  SysMetrics, Metrics: TTextMetric;
begin
  if NewStyleControls then begin
     if BorderStyle = bsNone then
        I := 0
     else if Ctl3D then
        I := 1
     else
        I := 2;

     Result.X := SendMessage(Handle, EM_GETMARGINS, 0, 0) and $0000FFFF + I;
     Result.Y := I;

  end else begin
     if BorderStyle = bsNone then
        I := 0
     else begin
        DC := GetDC(0);
        GetTextMetrics(DC, SysMetrics);
        SaveFont := SelectObject(DC, Font.Handle);
        GetTextMetrics(DC, Metrics);
        SelectObject(DC, SaveFont);
        ReleaseDC(0, DC);
        I := SysMetrics.tmHeight;

        if I > Metrics.tmHeight then
           I := Metrics.tmHeight;

        I := I div 4;
     end;
     Result.X := I;
     Result.Y := I;
  end;
end;

procedure meuEdit.DataChange(Sender: TObject);
begin
  if csDesigning in ComponentState then
     EditText := Name;
end;

procedure meuEdit.WMCut(var Message: TMessage);
begin
  inherited;
end;

procedure meuEdit.WMPaste(var Message: TMessage);
begin
  inherited;
end;

procedure meuEdit.Reset;
begin
  SelectAll;
end;

Function meuEdit.PoeMascara (pTexto : String) : String;
Var	Aux : String;
		I, J : Integer;
begin
	If(EditMask='') Or (EditMask='*') Then Begin
	  Result := pTexto;
    Exit;
  End;

     pTexto := TiraMascara(pTexto);
     Aux := '';
     J := 0;
     for I := 1 to Length(EditMask) do
       if (EditMask [I] = '9') or (EditMask [I] = 'A') or (EditMask [I] = 'a') then
         begin
          if J < Length(pTexto) then
           begin
                 J := J + 1;
                 Aux := Aux + pTexto[J];
           end
          else
              Aux := Aux + ' '
         end
       else
         Aux := Aux + EditMask[I];
       Result := Aux;
end;

function meuEdit.TiraMascara (pTexto : String) : String;
var
   Aux : String;
   I : Integer;
begin
     Aux := '';
     for I := 1 to Length(pTexto) do
     begin
          if (not EMascara(pTexto[I])) and (pTexto[I] <> '_') then
             Aux := Aux + pTexto[I];
     end;
     Result := Aux;
end;

function meuEdit.EMascara (L : Char) : Boolean;
begin
     if (L in ['.', ',', '/', '-',':','*']) then
        Result := true
     else
         Result := false;
end;

procedure meuEdit.KeyPress(var Key: Char);
var
   L, M : Char;
   P, I : Integer;
   Texto:String;
begin
	//showmessage(edittext);
	If(EditMask<>'99/99/9999') Then Begin
  	If (Length(Text)>=MaxLength) And (MaxLength>0) Then
  		Text:=Copy(Text,1,MaxLength)//Key:=#0;
  End;


		if(Key=Chr(39)) Then
    	Key:=#0;

     if (Key = #8) then
        begin
             if EditMask <> '' then
                Key := #0
             else
                 inherited;
             Exit;
        end;
        if (EditMask = '') or (Key = #13) then
           begin
                inherited;
                Exit;
           end;
        if EditMask = '*' then
           begin
                Texto := Copy(Texto, 1, SelStart) + Key +
                         Copy(Texto, SelStart + SelLength + 1, Length(Text));
                         Key := '*';
                         Exit;
           end;
           P := SelStart;
           L := Key;
           M := EditMask [P + 1];
           if EMascara (M) then
              P := P + 1;
           M := EditMask [P + 1];
           if not EMascara (L) then
             begin
              if (M = '9') then
                begin
                   if not (L in ['0'..'9']) then
                     begin
                        Key := #0;
                        Exit;
                     end;
                end
              else
                begin
                  if (M = 'A') or (M = 'a') then
                    begin
                      if (M = 'a') then
                        L := LowerCase (L) [1]
                      else
                        L := UpperCase (L) [1];
                    end;
                end;
              if Length(SelText) = 0 then
                Text := Copy(Text, 1, P) + L + Copy(Text, P + 2, Length(Text))
              else
                Text := Copy(Text, 1, SelStart) + L +
                        Copy(Text, SelStart + Length(SelText) + 1, Length(Text));
              Text := PoeMascara(Text);
              SelStart := P + 1;
              if EMascara (Text[P + 2]) then
                SelStart := P + 2
              else
                SelStart := P + 1;
              Key := #0;
             end;
end;

{
procedure meuEdit.KeyPress(var Key: Char);
begin
	inherited KeyPress(Key);
	If fTipo in [mefloatMenorIgualZero, mefloatMenorZero, mefloatValido, medataMenorHoje, medataMaiorHoje, medataValida] Then Begin

     if pos(key, '0123456789.,-') = 0 then
        key := #0;

     if (fTipo in [medataMaiorHoje, medataMenorHoje, medataValida]) and (pos(key, '.,') > 0) then
        key := #0;

		If (Key = '.') Then
    	   Key:=',';
	End;
end;
}
procedure meuEdit.KeyDown(var Key: Word; Shift: TShiftState);
begin
  inherited KeyDown(Key, Shift);
end;

function meuEdit.EditCanModify: Boolean;
begin
end;

procedure meuEdit.Change;
begin
  inherited Change;

  if fTipo in [mefloatMenorIgualZero, mefloatMenorZero, meFloatValido, meinteiroValido, meinteiroMenorIgualZero, meinteiroMenorZero] then
     fAlignment := taRightJustify;
end;

procedure meuEdit.WMPaint(var Message: TWMPaint);
var
  Left: Integer;
  Margins: TPoint;
  R: TRect;
  DC: HDC;
  PS: TPaintStruct;
  S: string;
begin
  if ((FAlignment = taLeftJustify) or FFocused) and not (csPaintCopy in ControlState) then begin
    inherited;
    Exit;
  end;

  { Since edit controls do not handle justification unless multi-line (and
  then only poorly) we will draw right and center justify manually unless
  the edit has the focus. }
  if FCanvas = nil then begin
    FCanvas := TControlCanvas.Create;
    FCanvas.Control := Self;
  end;

  DC := Message.DC;
  if DC = 0 then
     DC := BeginPaint(Handle, PS);
  FCanvas.Handle := DC;

  try
    FCanvas.Font := Font;
    with FCanvas do begin
      R := ClientRect;
      if not (NewStyleControls and Ctl3D) and (BorderStyle = bsSingle) then
      begin
        Brush.Color := clWindowFrame;
        FrameRect(R);
        InflateRect(R, -1, -1);
      end;
      Brush.Color := Color;
{      if (csPaintCopy in ControlState) and (FDataLink.Field <> nil) then
      begin
        S := FDataLink.Field.DisplayText;
        case CharCase of
          ecUpperCase: S := AnsiUpperCase(S);
          ecLowerCase: S := AnsiLowerCase(S);
        end;
      end else}
        S := EditText;
      if PasswordChar <> #0 then FillChar(S[1], Length(S), PasswordChar);
      Margins := GetTextMargins;
      case FAlignment of
        taLeftJustify: Left := Margins.X;
        taRightJustify: Left := ClientWidth - TextWidth(S) - Margins.X - 1;
      else
        Left := (ClientWidth - TextWidth(S)) div 2;
      end;
      TextRect(R, Left, Margins.Y, S);
    end;
  finally
    FCanvas.Handle := 0;
    if Message.DC = 0 then EndPaint(Handle, PS);
  end;
end;

procedure meuEdit.SetNumero(Value : string);
var Inteiro,
    Centavo : string;
//    f,  {quem tirou foi orlando}
    Len,
    n : Integer;  {N de Digitos }
begin
     Len := Length(Value);
     n := Pos(',', Value);
     {Formatando a Vrgula e os Centavos}
     if n = 0
       then
         Value := Value + ',00'
       else
         if Len > n + 2
           then
             Delete(Value, n+3, Len-n+2)
           else
             if Len < n + 2
               then
                 Insert(Copy('00', 1, n + 2 - Len) , Value, n + 1);
     if Value = '0,00'
       then
         begin
           FExtenso := '';
           Exit;
         end;
     n := Pos(',', Value);
     Inteiro := Copy(Value, 1, n - 1);
     Centavo := Copy(Value, n + 1, 2);
     Len := Length(Inteiro);
     case Len of
       1 : FExtenso := Ext1(Inteiro);
       2 : FExtenso := Ext1(Inteiro);
       3 : FExtenso := Ext1(Inteiro);
       4 : FExtenso := Ext2(Inteiro);
       5 : FExtenso := Ext2(Inteiro);
       6 : FExtenso := Ext2(Inteiro);
       else
         FExtenso := Value;
     end;
     if (StrToInt(Inteiro) <> 1) and (StrToInt(Inteiro) <> 0)
       then FExtenso := FExtenso + FPluralMoeda + ' '
       else FExtenso := FExtenso + FMoeda + ' ';
     if Centavo <> '00'
       then
         if StrToInt(Inteiro) <> 0
           then
             begin
               if Centavo <> '01'
                 then FExtenso := FExtenso + 'e ' + Ext1(Centavo) + FPluralFracao
                 else FExtenso := FExtenso + 'e um ' + FFracao
             end
           else
             begin
               if Centavo <> '01'
                 then FExtenso := Ext1(Centavo) + FPluralFracao
                 else FExtenso := 'um ' + FFracao
             end;
     FNumero := Value;
end;

procedure meuEdit.SetMoeda(Value : string);
begin
     FMoeda := Value;
     SetNumero(FNumero);
end;

procedure meuEdit.SetPluralMoeda(Value : string);
begin
     FPluralMoeda := Value;
     SetNumero(FNumero);
end;

procedure meuEdit.SetFracao(Value : string);
begin
     FFracao := Value;
     SetNumero(FNumero);
end;

procedure meuEdit.SetPluralFracao(Value : string);
begin
     FPluralFracao := Value;
     SetNumero(FNumero);
end;

function meuEdit.Ext1(S : string) : string;
begin
     case Length(S) of
       1 : Result := ExtUnidade(S[1]);
       2 : Result := ExtDezena(S[1] + S[2]);
       3 : if S[2] + S[3] = '00'
             then Result := Centena[StrToInt(S[1])]
             else
               if S[1] = '1'
                 then Result := 'cento e ' + ExtDezena(S[2] + S[3])
                 else Result := Centena[StrToInt(S[1])] + 'e ' + ExtDezena(S[2] + S[3]);
     end;
end;

function meuEdit.ExtUnidade(S : string) : string;
begin
     Result := Unidade[StrToInt(S[1])];
end;

function meuEdit.ExtDezena(S : string) : string;
begin
     if S[1] <> '1'
       then
         {Dezena <> 1}
         if S[2] <> '0'
           then
             if S[1] <> '0'
               then Result := Dezena[StrToInt(S[1])] + 'e ' + Unidade[StrToInt(S[2])]
               else Result := Unidade[StrToInt(S[2])]
           else Result := Dezena[StrToInt(S[1])]
       else
         {Dezena = 1}
         case S[2] of
           '0' : Result := 'dez ';
           '1' : Result := 'onze ';
           '2' : Result := 'doze ';
           '3' : Result := 'treze ';
           '4' : Result := 'quatorze ';
           '5' : Result := 'quinze ';
           '6' : Result := 'dezesseis ';
           '7' : Result := 'dezessete ';
           '8' : Result := 'dezoito ';
           '9' : Result := 'dezenove ';
         end;
end;

function meuEdit.Ext2(S : string) : string;
begin
     case Length(S) of
       4 : if Copy(S,1,1) <> '0'
             then Result := Ext1(Copy(S,1,1)) + 'mil ' + Ext1(Copy(S,2,3))
             else Result := Ext1(Copy(S,2,3));
       5 : if Copy(S,1,2) <> '00'
             then Result := Ext1(Copy(S,1,2)) + 'mil ' + Ext1(Copy(S,3,3))
             else Result := Ext1(Copy(S,3,3));
       6 : if Copy(S,1,3) <> '000'
             then Result := Ext1(Copy(S,1,3)) + 'mil ' + Ext1(Copy(S,4,3))
             else Result := Ext1(Copy(S,4,3));
     end;
end;



Procedure Register;
Begin
  RegisterComponents('Standard', [meuEdit]);
End;

End.


